#ONLY CONNECT TO PORT 2
class color:
    #type can be rgb,color,reflect,ambient
    def __init__(self,thread, port):
        self.__thread=thread
        self.__number=thread.add_sensor(port,"color")
        self.__mode="ambient"
        
    def get_value(self):
        self.__thread.update_sensors()
        return self.__thread.get_sensor_value(self.__number)
    
    def get_color_string(self):
        try:
            return ["NONE", "BLACK", "BLUE", "GREEN", "YELLOW", "RED", "WHITE", "BROWN"][self.get_value()]
        except IndexError:
            return "NONE"
    def set_reflect_mode(self):
        self.__thread.queue_put(["command",["color_reflect",("sensor_number",self.__number)]])
        self.__mode="reflect"
    def set_ambient_mode(self):
        self.__thread.queue_put(["command",["color_ambient",("sensor_number",self.__number)]])
        self.__mode="ambient"
    def set_color_mode(self):
        self.__thread.queue_put(["command",["color_color",("sensor_number",self.__number)]])
        self.__mode="color"
    def set_rgb_raw_mode(self):
        self.__thread.queue_put(["command",["color_rgb",("sensor_number",self.__number)]])
        self.__mode="rgb"
class IR:
    
    def __init__(self,thread, port):
        self.__thread=thread
        self.__number=thread.add_sensor(port,"IR")
        self.__mode="prox"
    
    def get_value(self):
        self.__thread.update_sensors()
        return self.__thread.get_sensor_value(self.__number)
    
    def set_proximity_mode(self):
        self.__thread.queue_put(["command",["IR_prox",("sensor_number",self.__number)]])
        
    def set_seek_mode(self):
        self.__thread.queue_put(["command",["IR_seek",("sensor_number",self.__number)]])
        
    def set_remote_control_mode(self):
        self.__thread.queue_put(["command",["IR_remote",("sensor_number",self.__number)]])
from math import floor

class motor:
    #port is A,B,C,D no syncronised objects can be created so far
    def __init__(self,thread, port):
        self.__thread=thread
        if port in ["A","B","C","D"]:
            self.__port=port
        else:
            raise SyntaxError("invalid port")
        self.__thread.queue_put(["command",["add_motor",("",self.__port)]])
    
    def reset(self):
        self.__thread.queue_put(["command",["reset_motor",("",self.__port)]])
    def stop(self):
        self.change_attribute_list([["run",False]])

    def change_attribute(self,attribute,value):
        self.__thread.queue_put(["command",["attribute_motor",("",self.__port),("attribute",attribute),("value",value)]])
        #list_of_attributes=[["duty_cycle",0],["estop",false]]
        #speed =+-100
    def run_forever(self,speed):
        if type(speed)==int and abs(speed)<=100:
            if speed!=0:
                self.change_attribute_list([["run_mode","forever"],["regulation_mode","off"],["duty_cycle_sp",speed],["run",True]])
            else:
                self.stop()
    #speed=+-100, time is in milliseconds
    def run_time_limited(self,speed,time):
        if type(speed)==int and abs(speed)<=100 and type(time)==int and time>0:
            self.change_attribute_list([["run_mode","time"],["regulation_mode","off"],["duty_cycle_sp",speed],["time_sp",time],["stop_mode","brake"],["run",True]])
    #speed=+-100,degree 
    def run_position_limited(self,speed,position):
        if type(speed)==int and speed<=100 and speed>0 and type(position)==int:
            self.change_attribute_list([["run_mode","position"],["regulation_mode","on"],["ramp_up_sp",300],["ramp_down_sp",300],["position",0],["pulses_per_second_sp",speed*9],["position_sp",position],["stop_mode","brake"],["hold_mode","on"],["run",True]])
    def change_attribute_list(self,list_of_attributes):
        self.__thread.queue_put(["command",["attribute_motor_list",("",self.__port),("list_of_attribute",list_of_attributes)]])
class speak:
    
    def __init__(self,thread):
        self.__thread=thread
        #example lang is en,fi,sv
    def talk(self,text,lang="en"):
        print("adding to queue")
        self.__thread.queue_put(["command",["speak",("",lang),("",text)]])
class touch:
    
    def __init__(self,thread, port):
        self.__thread=thread
        self.__number=thread.add_sensor(port,"touch")
    def is_pressed(self):
        self.__thread.update_sensors()
        return self.__thread.get_sensor_value(self.__number)
    